/*
 * $Id: scan.c,v 1.2 2003/06/26 22:55:41 ldemailly Exp $
 *
 * Copyright (c) 2003, Qualys, Inc.  All rights reserved.
 *
 * See the file LICENSE for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <libqg.h>

int main(int argc, char *argv[])
{
    qgresponse_t *res = NULL;
    qghandle_t *handle = NULL;
    xmlNodePtr cur = NULL;
    char *ref = NULL;

    if (argc < 4) {
        printf("Usage: %s ip_address username password\n", argv[0]);
        exit(-1);
    }
    // Init handle
    if ((handle = qg_init(argv[2], argv[3])) == NULL) {
        perror("qg_init failed");
        exit(-1);
    }
    // Scan a single IP
    res =
        qg_scan(handle, argv[1], 1, NULL,
                "https://qualysguard.qualys.com/msp/scan.php?");

    // Did we get a response?
    if (res && res->xml) {
        // Determine Newest Report
        if ((ref = qg_xml_fetch_report(res->xml)) != NULL) {
            // Grab latest report
            res =
                qg_scan_report(handle, ref, NULL,
                               "https://qualysguard.qualys.com/msp/scan_report.php?");

            // Did we get a valid response?
            if (res && res->xml) {
                // Parse information
                if ((cur = qg_xml_find_ip(res->xml, argv[1])) != NULL) {
                    printf("*** OS: ***\n%s\n", qg_xml_fetch_os(cur));
                    printf("*** TCP: ***\n%s\n", qg_xml_fetch_tcp(cur));
                    printf("*** UDP: ***\n%s\n", qg_xml_fetch_udp(cur));
                    printf("*** RPC: ***\n%s\n", qg_xml_fetch_rpc(cur));
                }
            }
        }
    }

    exit(0);
}
