/*
 * $Id: qg_map.c,v 1.12 2003/08/19 02:20:57 mkrieger Exp $
 *
 * Copyright (c) 2003, Qualys, Inc.  All rights reserved.
 *
 * See the file LICENSE for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include "libqgInt.h"

/**
 * qg_map connects to QualysGuard with qg_fetch and returns a qgresponse
 * with a XML-document containing an inventory of network devices
 * returns NULL on error
 */
qgresponse_t *qg_map(qghandle_t * qgh, char *domain, int save, char *sname)
{
    char baseurl[STR_BUF_LEN];
    char *url = NULL;
    qgresponse_t *qgr = NULL;

    if (!domain || !qgh) {
        qg_error(0, LIBQG_MAP, LIBQG_ERR_MISPAR, "qghandle / domain");
        return (NULL);
    }

    snprintf(baseurl, STR_BUF_LEN, "%s/%s/%s", base_url, MSP_DIR, M_URL);
    // Copy base url
    if ((url = (char *) strdup(baseurl)) == NULL) {
        qg_error(0, LIBQG_MAP, LIBQG_ERR_STRDUP);
        return (NULL);
    }
    // Addresses
    url = qg_strappend(url, ARG_DOMAIN);
    url = qg_strappend(url, domain);

    // Save on Server?
    if (save) {
        url = qg_strappend(url, ARG_SAVEREP_Y);
    } else {
        url = qg_strappend(url, ARG_SAVEREP_N);
    }

    // Iscanner specified?
    if (sname) {
        url = qg_strappend(url, ARG_ISCAN_NAME);
        url = qg_strappend(url, sname);
    }
    // fetch page
    qgr = qg_fetch(qgh, url);
    free(url);
    return (qgr);
}
