/*
 * $Id: qg_map_report_list.c,v 1.13 2003/08/19 02:20:57 mkrieger Exp $
 *
 * Copyright (c) 2003, Qualys, Inc.  All rights reserved.
 *
 * See the file LICENSE for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include "libqgInt.h"

/**
 * qg_map_report_list connect to QualysGuard with qg_fetch and returns
 * a qgresponse containing a XML-document with a list of saved map 
 * reports.
 * returns NULL on error
 */
qgresponse_t *qg_map_report_list(qghandle_t *qgh, int last, char *domain)
{
    char baseurl[STR_BUF_LEN];
    char *url = NULL;
    qgresponse_t *qgr = NULL;

    if (!qgh) {
        qg_error(0, LIBQG_MAP_REP_LIS, LIBQG_ERR_MISPAR, "qghandle");
    }

    snprintf(baseurl, STR_BUF_LEN, "%s/%s/%s", 
             base_url, MSP_DIR, MREPORTLIST_URL);
    // Copy base url
    if ((url = (char *) strdup(baseurl)) == NULL) {
        qg_error(0, LIBQG_MAP_REP_LIS, LIBQG_ERR_STRDUP);
        return (NULL);
    }
    // View last?
    if (last) {
        url = qg_strappend(url, ARG_LAST_Y);
    } else {
        url = qg_strappend(url, ARG_LAST_N);
    }

    // Addresses
    if (domain) {
        url = qg_strappend(url, ARG_DOMAIN);
        url = qg_strappend(url, domain);
    }
    // fetch page
    qgr = qg_fetch(qgh, url);
    free(url);
    return (qgr);
}
