/*
 * $Id: qg_scan_report_delete.c,v 1.12 2003/08/19 02:20:57 mkrieger Exp $
 *
 * Copyright (c) 2003, Qualys, Inc.  All rights reserved.
 *
 * See the file LICENSE for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include "libqgInt.h"

/**
 * qg_scan_delete connects to QualysGuard with qg_fetch and tells
 * QualysGuard to delete the report with the reference-code 
 * specified by 'ref'
 * returns NULL on error
 */
qgresponse_t *qg_scan_delete(qghandle_t *qgh, char *ref)
{
    char baseurl[STR_BUF_LEN];
    char *url = NULL;
    qgresponse_t *qgr = NULL;

    if (!ref || !qgh) {
        qg_error(0, LIBQG_SCAN_DEL, LIBQG_ERR_MISPAR, 
                 "qghandle / reference code");
        return (NULL);
    }

    snprintf(baseurl, STR_BUF_LEN, "%s/%s/%s", 
             base_url, MSP_DIR, SREPORTDEL_URL);
    // Copy base url
    if ((url = (char *) strdup(baseurl)) == NULL) {
        qg_error(0, LIBQG_SCAN_DEL, LIBQG_ERR_STRDUP);
        return (NULL);
    }
    // Report ID
    url = qg_strappend(url, ARG_REFER);
    url = qg_strappend(url, ref);

    // fetch page
    qgr = qg_fetch(qgh, url);
    free(url);
    return (qgr);
}
