/*
 * $Id: qg_scan_running_list.c,v 1.12 2003/08/19 02:20:57 mkrieger Exp $
 *
 * Copyright (c) 2003, Qualys, Inc.  All rights reserved.
 *
 * See the file LICENSE for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include "libqgInt.h"

/**
 * qg_scan_running_list connects with qg_fetch() to QualysGuard and
 * returns a XML-report containing all running scans
 * returns NULL on error
 */
qgresponse_t *qg_scan_running_list(qghandle_t *qgh)
{
    qgresponse_t *qgr = NULL;
    char baseurl[STR_BUF_LEN];
    char *url = NULL;

    if (!qgh) {
        qg_error(0, LIBQG_SCAN_RUN_LIS, LIBQG_ERR_MISPAR, "qghandle");
        return (NULL);
    }

    snprintf(baseurl, STR_BUF_LEN, "%s/%s/%s", base_url, MSP_DIR, SLIST_URL);
    // Copy base url
    if ((url = (char *) strdup(baseurl)) == NULL) {
        qg_error(0, LIBQG_SCAN_RUN_LIS, LIBQG_ERR_STRDUP);
        return (NULL);
    }
    // fetch page
    
    qgr = qg_fetch(qgh, url);
    free(url);
    return (qgr);
}
