/*
 * $Id: qg_vulnmap.c,v 1.12 2003/09/09 17:10:03 mkrieger Exp $
 *
 * Copyright (c) 2003, Qualys, Inc.  All rights reserved.
 *
 * See the file LICENSE for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include "libqgInt.h"

// TODO: return a better, more efficient data structure (for
// searching/matching). This is WIP and experimental API1.2
// candidate (not deployed yet).

/** 
 * qg_cve_list uses qg_fetch to connect to QualysGuard and fetch
 * a list of CVEs, which is returned. If no valid XML document is 
 * returned by qg_fetch it returns NULL (qg error is set).
 */
qgresponse_t *qg_cve_list(qghandle_t *qgh)
{
    char url[STR_BUF_LEN];
    qgresponse_t *qgr = NULL;
    
    snprintf(url, STR_BUF_LEN, "%s/%s/%s", base_url, MSP_DIR, 
             "vulnmap.php?in-type=CVE&out-type=QUALYS");


    qgr = qg_fetch(qgh, url);

    if (qgr == NULL) {
        return NULL;
    }

    libqg_message(0, "qg_cve_list fetched %zd bytes; status %d", qgr->size, 
                     qgr->httpCode);
    return qgr;
}

/**
 * qg_xmlroot returns the first children of the documentroot element
 * NULL is returned on an error
 */
xmlNodePtr qg_xmlroot(xmlDocPtr doc, char *start)
{
    xmlNodePtr root = NULL;

    if (!doc) {
        qg_error(0, "qg_xmlroot", "No xml-document-pointer.");
        return NULL;
    }

    if ((root = xmlDocGetRootElement(doc)) == NULL) {
        qg_error(0, "qg_xmlroot", "No root-element for XML.");
        return NULL;
    }

    while(root != NULL && strcmp(root->name, start) != 0) {
        root = root->next;
    }
    
    return root;
}
